#include "StdAfx.h"

#define SERVICE_NOT_PRESENT 0 

HOOKPROC hkprcSysMsg; 
static HHOOK hhookSysMsg; 

BOOL bCreated = FALSE;
BOOL UnloadProfile;
BOOL RebootNow = FALSE;

#define FAST_REBOOT_APP_CLASS       TEXT("FastRebootAppClass")
#define FAST_REBOOT_SERVICE_NAME    TEXT("FastRebootService")

SERVICE_STATUS_HANDLE StatusHandle;

#pragma pack(push,1)
#pragma pack(1)
struct INJECTORCODE
{
  BYTE  instr_push_loadlibrary_arg; 
  DWORD loadlibrary_arg;            

  WORD  instr_call_loadlibrary;     
  DWORD adr_from_call_loadlibrary;

  BYTE  instr_push_exitthread_arg;
  DWORD exitthread_arg;

  WORD  instr_call_exitthread;
  DWORD adr_from_call_exitthread;

  DWORD addr_loadlibrary;
  DWORD addr_exitthread;     
  BYTE  libraryname[MAX_PATH];    
};
#pragma pack(pop,1)


typedef enum SHUTDOWN_ACTION_TAG {
    ShutdownNoReboot,
    ShutdownReboot,
    ShutdownPowerOff
} SHUTDOWN_ACTION;


ULONG (__stdcall *NtShutdownSystem) (
    IN SHUTDOWN_ACTION Action
);

ULONG (__stdcall *NtQuerySystemInformation) (
    ULONG   SystemInformationClass,
    PVOID   SystemInformation,
    ULONG   SystemInformationLength,
    PULONG  ReturnLength
);


BOOL InjectDll(DWORD pid, char *lpszDllName)
{
    HANDLE hProcess;
    BYTE *p_code;
    INJECTORCODE cmds;
    DWORD wr, id;

    hProcess=OpenProcess(PROCESS_CREATE_THREAD|PROCESS_VM_WRITE|PROCESS_VM_OPERATION, FALSE, pid);

    if (hProcess == NULL) return FALSE;
    
    p_code = (BYTE*)VirtualAllocEx(hProcess, 0, sizeof(INJECTORCODE),
                                   MEM_COMMIT, PAGE_EXECUTE_READWRITE);
    if(p_code==NULL) return FALSE;

    cmds.instr_push_loadlibrary_arg = 0x68; 
    cmds.loadlibrary_arg = (DWORD)((BYTE*)p_code 
             + offsetof(INJECTORCODE, libraryname));
    
    cmds.instr_call_loadlibrary = 0x15ff;
    cmds.adr_from_call_loadlibrary = 
    (DWORD)(p_code + offsetof(INJECTORCODE, addr_loadlibrary));
    
    cmds.instr_push_exitthread_arg  = 0x68;
    cmds.exitthread_arg = 0;
    
    cmds.instr_call_exitthread = 0x15ff; 
    cmds.adr_from_call_exitthread = 
    (DWORD)(p_code + offsetof(INJECTORCODE, addr_exitthread));
    
    cmds.addr_loadlibrary = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"), "LoadLibraryA");
    
    cmds.addr_exitthread  = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"),"ExitThread");
    
    if(strlen(lpszDllName)>MAX_PATH) {
        return FALSE;
    }

    strcpy((char*)cmds.libraryname, lpszDllName );

    WriteProcessMemory(hProcess, p_code, &cmds, sizeof(cmds), &wr);
    
    HANDLE z = CreateRemoteThread(hProcess, NULL, 0, 
                 (unsigned long (__stdcall *)(void *))p_code, 0, 0, &id);

    WaitForSingleObject(z, INFINITE);

    VirtualFreeEx(hProcess, (void*)p_code, sizeof(cmds), MEM_RELEASE);

    return TRUE;
}

typedef LONG    NTSTATUS;
typedef LONG    KPRIORITY;

#define STATUS_INFO_LENGTH_MISMATCH      (0xC0000004L)

#define SystemProcessesAndThreadsInformation    5

typedef struct _CLIENT_ID {
    DWORD         UniqueProcess;
    DWORD         UniqueThread;
} CLIENT_ID;

typedef struct _UNICODE_STRING {
    USHORT        Length;
    USHORT        MaximumLength;
    PWSTR         Buffer;
} UNICODE_STRING;

typedef struct _VM_COUNTERS {
    SIZE_T        PeakVirtualSize;
    SIZE_T        VirtualSize;
    ULONG         PageFaultCount;
    SIZE_T        PeakWorkingSetSize;
    SIZE_T        WorkingSetSize;
    SIZE_T        QuotaPeakPagedPoolUsage;
    SIZE_T        QuotaPagedPoolUsage;
    SIZE_T        QuotaPeakNonPagedPoolUsage;
    SIZE_T        QuotaNonPagedPoolUsage;
    SIZE_T        PagefileUsage;
    SIZE_T        PeakPagefileUsage;
} VM_COUNTERS;

typedef struct _SYSTEM_THREADS {
    LARGE_INTEGER KernelTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER CreateTime;
    ULONG         WaitTime;
    PVOID         StartAddress;
    CLIENT_ID     ClientId;
    KPRIORITY     Priority;
    KPRIORITY     BasePriority;
    ULONG         ContextSwitchCount;
    LONG          State;
    LONG          WaitReason;
} SYSTEM_THREADS, * PSYSTEM_THREADS;

typedef struct _SYSTEM_PROCESSES {
    ULONG             NextEntryDelta;
    ULONG             ThreadCount;
    ULONG             Reserved1[6];
    LARGE_INTEGER     CreateTime;
    LARGE_INTEGER     UserTime;
    LARGE_INTEGER     KernelTime;
    UNICODE_STRING    ProcessName;
    KPRIORITY         BasePriority;
    ULONG             ProcessId;
    ULONG             InheritedFromProcessId;
    ULONG             HandleCount;
    ULONG             Reserved2[2];
    VM_COUNTERS       VmCounters;
#if _WIN32_WINNT >= 0x500
    IO_COUNTERS       IoCounters;
#endif
    SYSTEM_THREADS    Threads[1];
} SYSTEM_PROCESSES, * PSYSTEM_PROCESSES;

DWORD FindProcessPid(WCHAR *ImagePathName) {
    ULONG Status;
    ULONG cbBuffer = 0x8000;
    PVOID pBuffer = NULL;

    NtQuerySystemInformation = (unsigned long (__stdcall *)(ULONG   SystemInformationClass,
                                                            PVOID   SystemInformation,
                                                            ULONG   SystemInformationLength,
                                                            PULONG  ReturnLength)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtQuerySystemInformation" );

    do {
        pBuffer = GlobalAlloc(GMEM_FIXED, cbBuffer);

        Status = NtQuerySystemInformation(
                    SystemProcessesAndThreadsInformation,
                    pBuffer, cbBuffer, NULL);

        if (Status == STATUS_INFO_LENGTH_MISMATCH) {
            GlobalFree(pBuffer);
            cbBuffer *= 2;
        }
    } while (Status == STATUS_INFO_LENGTH_MISMATCH ||
             Status == 0);

    PSYSTEM_PROCESSES pProcesses = (PSYSTEM_PROCESSES)pBuffer;

    for (;;) {
        if (memcmp(pProcesses->ProcessName.Buffer,ImagePathName,pProcesses->ProcessName.Length) == 0) {
            GlobalFree(pBuffer);
            return pProcesses->ProcessId;
        }
        pProcesses = (PSYSTEM_PROCESSES)(((LPBYTE)pProcesses)
                        + pProcesses->NextEntryDelta);
    }

    GlobalFree(pBuffer);
    return 0;

}

BOOL GainAllPrivileges(void)
{
    HANDLE              hToken;
    PTOKEN_PRIVILEGES   tp;
    DWORD               ReturnLength;
    DWORD               i;
    //
    // obtain the token, first check the thread and then the process
    //
    if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hToken)){
        if (GetLastError() == ERROR_NO_TOKEN){
            if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
                return FALSE;
        } else return FALSE;
    }

    GetTokenInformation(hToken,TokenPrivileges, NULL,0L, &ReturnLength);
    tp = (PTOKEN_PRIVILEGES)GlobalAlloc(GMEM_FIXED,ReturnLength);
    GetTokenInformation(hToken,TokenPrivileges, tp, ReturnLength, &ReturnLength);

    for (i=0; i<tp->PrivilegeCount;i++) {
        tp->Privileges[i].Attributes = SE_PRIVILEGE_ENABLED;
    }

    if (!AdjustTokenPrivileges(hToken, FALSE, tp, 0, ( PTOKEN_PRIVILEGES)NULL, 0))
         return FALSE;

    if (!CloseHandle(hToken))
         return FALSE;

    GlobalFree(tp);
    return TRUE;
}

PCHAR __cdecl strrchr (
        PCHAR string,
        CHAR ch
        )
{
        PCHAR start = (PCHAR)string;

        while (*string++)
                ;
        while (--string != start && *string != ch)
                ;

        if (*string == ch)
                return( (PCHAR)string );

        return(NULL);
}

VOID
RebootImmediately()
{
    WCHAR SystemRoot[MAX_PATH];
    WCHAR WinLogonPath[MAX_PATH];
    CHAR PUHandlerPath[MAX_PATH];
    
    if (UnloadProfile) {
        GetSystemDirectoryW(SystemRoot,MAX_PATH);
        wsprintfW(WinLogonPath,L"\\??\\%s\\winlogon.exe",SystemRoot);
        GetModuleFileName(NULL, PUHandlerPath, MAX_PATH);
        *(strrchr(PUHandlerPath, '\\') + 1) = '\0';
        strcat(PUHandlerPath,"PUHandler.dll");

        GainAllPrivileges();

        InjectDll(FindProcessPid(WinLogonPath),PUHandlerPath);
                    
        ExitWindowsEx(EWX_LOGOFF | EWX_FORCE , 0);
    } else {
        GainAllPrivileges();
        NtShutdownSystem = (unsigned long (__stdcall *)(enum SHUTDOWN_ACTION_TAG)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtShutdownSystem" );
        NtShutdownSystem(ShutdownReboot);
    }
}

LRESULT CALLBACK
MyKeyboardProc(
    int nCode,     // hook code
    WPARAM wParam, // message identifier
    LPARAM lParam  // message data
) {
    if(nCode < 0)
        return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);

    PKBDLLHOOKSTRUCT hookParams = (PKBDLLHOOKSTRUCT)lParam;

    if(wParam == WM_KEYDOWN || wParam == WM_SYSKEYDOWN) {
        if( (hookParams->scanCode == 0x53) &&
            (GetAsyncKeyState(VK_SHIFT)   & 0x80000000) &&
            (GetAsyncKeyState(VK_CONTROL) & 0x80000000)  &&
            (GetAsyncKeyState(VK_MENU)    & 0x80000000)) {

            RebootImmediately();

            return 1;
        }
    }

    return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);
}


LONG APIENTRY MainWndProc(
    HWND hWnd,                
    UINT message,             
    UINT wParam,              
    LONG lParam)              
{

    switch (message) 
    {
        case WM_CREATE:
            return 0;
 
        case WM_WINDOWPOSCHANGING:
            if (bCreated) {  
                LPWINDOWPOS lpwp;
               
                // correct WINDOWPOS parameters
                lpwp = (LPWINDOWPOS) lParam; // points to size and position data 
                lpwp->flags = SWP_NOMOVE    | SWP_NOOWNERZORDER |
                              SWP_NOSIZE | SWP_NOREDRAW | 
                              SWP_NOREPOSITION;

            } else { 
                bCreated = TRUE;
            }
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (0);
}


BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wcSample;
    wcSample.style = 0;                     
    wcSample.lpfnWndProc = (WNDPROC)MainWndProc; 
    wcSample.cbClsExtra = 0;
    wcSample.cbWndExtra = 0;
    wcSample.hInstance = (HINSTANCE)hInstance;       
    wcSample.hIcon = NULL; 
    wcSample.hCursor = NULL;
    wcSample.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); 
    wcSample.lpszMenuName =  NULL;  
    wcSample.lpszClassName = FAST_REBOOT_APP_CLASS;

    return (RegisterClass(&wcSample));
}

/// Perofrom instance-specific intialization
BOOL InitInstance(
    HANDLE          hInstance,
    int             nCmdShow) 
{

    HWND hWndMain;

    hWndMain = CreateWindow(
        FAST_REBOOT_APP_CLASS,
        TEXT("Fast Reboot Application"),
        WS_OVERLAPPEDWINDOW, 
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
        NULL,               
        NULL,               
        (HINSTANCE)hInstance,          
        NULL);

    if (!hWndMain)
        return (FALSE);

    ShowWindow(hWndMain, SW_HIDE);
//    ShowWindow(hWndMain, SW_SHOW);
    UpdateWindow(hWndMain); 
    return (TRUE);      

}


VOID print_help(VOID) {
    MessageBox(NULL,"Fast Reboot by Alter & Axxie v 1.0.e\n\n"
                    "Usage:\n"
                    "\tfreboot\t[-<switches>]\n"
                    "Exclusive switches:\n"
                    "\ti\treboot immediately\n"
                    "\tr\treboot\n"
                    "\ts,h\tshutdown\n"
                    "\tl\tlogoff\n"
                    "\tp\tpoweroff\n"
                    "Optional switch:\n"
                    "\tf\tforces processes to terminate\n"
                    "\tu\tunload user profile before Fast Reboot\n"
                    "\t?\tthis help\n\n"
                    "Installs FastReboot Hook if started without parameters.\n"
                    "The Hook enables Fast Reboot similar to Quick Reboot\n"
                    "from Windows NT in 2000/XP/2003.\n"
                    "You can use ALT+CTRL+SHIFT+DEL to reboot immediately\n",
                    "Usage",
                    MB_OK);
}
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow) {
    MSG msg;                       
    ULONG i;
    ULONG Flags = 0;
    ULONG lim;
    BOOLEAN break_on_q = FALSE;
    BOOLEAN break_name = FALSE;

    lpCmdLine = GetCommandLine();
    lim = strlen(lpCmdLine);

    if(lpCmdLine[0] == '\"') {
        break_on_q = TRUE;
    }
    for (i=1; !break_name && (i<lim-1) ;i++) {
        switch(lpCmdLine[i]) {
        case '\"':
            break_name = TRUE;
            break;
        case ' ':
        case '\t':
        case '\n':
        case '\r':
            if(!break_on_q) {
                break_name = TRUE;
            }
            break;
        }
    }

    for (;i<lim ;i++) {
        //if (i == 1 && lpCmdLine[i-1] == '-' ||
        //    lpCmdLine[i-1] == '-' && lpCmdLine[i-2] == ' ') {
        if(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t')
            continue;
        if(lpCmdLine[i] != '-') {
            print_help();
            return 0;
        }
        i++;
        if(i>=lim) {
            print_help();
            return 0;
        }
        for( ; (i<lim) && !(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t') ; i++) {
            switch(lpCmdLine[i]) {
                case '?' :
                    print_help();
                    return 0;
                case 'r' :
                    Flags |= EWX_REBOOT;
                    break;
                case 'i' :
                    RebootNow = TRUE;
                    break;
                case 's' :
                case 'h' :
                    Flags |= EWX_SHUTDOWN;
                    break;
                case 'l' :
                    Flags |= EWX_LOGOFF;
                    break;
                case 'p' :
                    Flags |= EWX_POWEROFF;
                    break;
                case 'f' :
                    Flags |= EWX_FORCE;
                    break;
                case 'u':
                    UnloadProfile = TRUE;
                    break;
                default:
                    print_help();
                    return 0;
            }
        }
    }

    if(RebootNow)
        RebootImmediately();

    if (Flags) {
        GainAllPrivileges();
        ExitWindowsEx(Flags, 0);
        return 0;
    }

    if (!InitApplication(hInstance))
        return (FALSE);     

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    hhookSysMsg = SetWindowsHookEx(WH_KEYBOARD_LL,&MyKeyboardProc,GetModuleHandle(NULL),0);

    if(!hhookSysMsg) {
        int RC=GetLastError();
        ExitProcess(RC);
    }

    while (GetMessage(&msg, NULL, 0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg); 
    }

    UnhookWindowsHookEx(hhookSysMsg);
   
    return (msg.wParam);  
    
}


